<?php
	require_once('../../majax.php');

	function processForm($arg)
	{

		$error = false;
		if (!$arg['userName']) { 
			Majax::Form()->addAlert('Please, fill username.');
			$error = true;
		}
		
		if (!$arg['newPass1'] || !$arg['newPass2']) { 
			Majax::Form()->addAlert('Please, fill password.');
			$error = true;
		}
		
		if ($arg['newPass1'] != $arg['newPass2']) { 
			Majax::Form()->addAlert('Passwords are diferent.');
			$error = true;
		}
		
		if (strlen($arg['newPass1']) < 8) { 
			Majax::Form()->addAlert('Password too short.');
			$error = true;
		}
		
		Majax::Form()->setFormValidity(!$error);
		//Majax::submitOnSuccess(true);
		
		Majax::send();	
		
	
	}
	$arg1 = array(	
		array(
			'method' => 'GET',
			'id' => 'registrationFormC', 
			'class'=>'majaxForm', 
			'action' => '', 
			'register' => array('registrationFormC', 'processForm')
		), 
		array(
			array(
				'id' => 'userName', 
				'type' => 'text', 
				'label' => 'Login: ',
				'value' => '',  
				'check' => array(
					MJX_C_MIN_LENGTH => array(5, 'Please fill login.')
				)
			),
			array(
				'id' => 'mail', 
				'type' => 'text', 
				'label' => 'Mail: ',
				'value' => '@',  
				'check' => array(
					MJX_C_MATCH => array('~[a-z]+@[a-z]+\.[a-z]+~', 'Incorect e-mail address.')
				)
			),								
			array(
				'id' => 'newPass1', 
				'type' => 'password', 
				'label' => 'Heslo: ',
				'check' => array(
					MJX_C_MIN_LENGTH => array(6, 'Minimal password length is 6.'), 
					MJX_C_SAME_AS => array('newPass2', 'Passwords must be same') 
				)
			),
			array(
				'id' => 'newPass2', 
				'type' => 'password', 
				'label' => 'Heslo: ', 
				'check' => array(
					MJX_C_MIN_LENGTH => 6, 
					MJX_C_SAME_AS => 'newPass1'
				)
			), 
			array(
				'id' => 'submit', 
				'type' => 'submit', 
				'value' => 'Odeslat', 
				'label' => ''
			)			 			 			 
			
		)
	);
	
	$arg2 = $arg1;
	unset($arg2[0]['register']);
	$arg3[0]['id'] = 'registrationFormD';
	
	$arg3 = $arg2;
	$arg3[0]['id'] = 'registrationFormE';
	$arg3[1][1]['check']['match'][0] = MJX_R_MAIL;
	
	$f1 = Majax::Form()->create($arg1);
	$f2 = Majax::Form()->create($arg2);
	$f3 = Majax::Form()->create($arg3);
	
	$f4 = Majax::Form()->create(
		array(
			array(
				'id' => 'selectFormA',
				'class'=>'majaxForm'
			), 
			array(	
				array(
					'id' => 'state1', 
					'type' => 'select', 
					'label' => 'State1: ',
					'value' => 'UK',
					'values' => array(
						array('Czech Republic', 'cr'),
						array('UK', 'uk'),  
						array('Slovak Republic', 'sk')
					), 
					'check' => array(
						MJX_C_IN_SELECT => array('', 'Invalid value')
					)
					
				),
				array(
					'id' => 'state2', 
					'type' => 'select', 
					'label' => 'State2: ',
					'value' => 'uk',
					'values' => array(
						array('Czech Republic', 'cr'),
						array('UK', 'uk'),  
						array('Slovak Republic', 'sk')
					), 
					'check' => array(
						MJX_C_IN_SELECT => 'Invalid value'
					)
				),			
				array(
					'id' => 'state3', 
					'type' => 'select', 
					'label' => 'State3: ',
					'values' => array(
						array('Czech Republic', 'cr'),
						array('UK', 'uk', 1),  					 
						array('Slovak Republic', 'sk')
					), 
					'check' => array(
						MJX_C_IN_SELECT => array('', 'Invalid value')
					)
				),	
				array(
					'id' => 'age', 
					'type' => 'text', 
					'label' => 'Age: ',
					'value' => '',  
					'check' => array(
						MJX_C_MIN_VALUE => array(1, 'Too young for our service.'), 
						MJX_C_MAX_VALUE => array(200, 'Too old for out service.')
					)
				),
				array(
					'id' => 'note', 
					'type' => 'textarea', 
					'label' => 'Note: ',
					'value' => ''
				),				
				array(
					'id' => 'submit', 
					'type' => 'submit', 
					'value' => 'Odeslat', 
					'label' => ''
				)			
				
			)
		)
	);
	
	$f1->setValues($_GET);
	$f2->setValues($_GET);
	
	$f1->process();
	$f2->process();
	Majax::process();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />

 <meta http-equiv="Content-language" content="cs" />
 <meta name="robots" content="index,follow" />
 <meta name="googlebot" content="index,follow" />
 <meta http-equiv="imagetoolbar" content="no" />
 <meta http-equiv="MSThemeCompatible" content="no" />
 <meta name="MS.LOCALE" content="cs" />

 <meta name="autosize" content="off" />
 <meta http-equiv="Cache-Control" content="must-revalidate, post-check=0, pre-check=0" />
 <meta http-equiv="Pragma" content="public" />

 <meta http-equiv="Cache-Control" content="no-cache" />
 <meta http-equiv="Pragma" content="no-cache" />
 <meta http-equiv="expires" content="-1" />
 <script type="text/javascript" src="../../majax.js"></script>
 <script type="text/javascript" src="example.js"></script>

</head>
<body>
<?php
	$f1->render();
	echo '<hr />';
	$f2->render();
	echo '<hr />';
	$f3->render();
	echo '<hr />';
	$f4->render();	
?>
</body>
</html>
