var majaxInstance = new Array();
var majaxInstanceId = 0;

/**
 * Majax
 */
var Majax = { 
	/// version of Majax library
	version: '0.0.1',
	
	/// default param name, that is used in request (GET/POST parametr name)
	paramName : 'majaxName', 
	
	/// I don't know
	result : false, 
	
	/// default HTTP method for requests
	method: "get", 
	
 	/// identifies browser
	Browser: {
		IE:     !!(window.attachEvent && !window.opera),
		Opera:  !!window.opera,
		WebKit: navigator.userAgent.indexOf('AppleWebKit/') > -1,
		Gecko:  (navigator.userAgent.indexOf('Gecko') > -1 && 
			navigator.userAgent.indexOf('KHTML') == -1)
	},
 
 	/// Creates AJAX requests.
	createRequest: function() { 
		return (typeof window.ActiveXObject != 'undefined') ? 
			new ActiveXObject("Microsoft.XMLHTTP") : 
			new XMLHttpRequest();
		
	}, 
	url : '', 
	onLoading : null, 
	onSuccess : null, 
	onFailure : null,
	state : { 
		NOT_INITIALIZED : 0, // not initialized.
		ESTABLISHED: 1, // connection established.
		REQUEST_RECIEVED : 2, // request received.
		ANSWER_ON_PROCESS : 3, // answer in process.
		FINISHED : 4 // finished. 
	},
	insertMode : { 
		FIRST : 0, 
		LAST : Number.MAX_VALUE, 
		REPLACE: -(Number.MAX_VALUE - 31415)
	}, 
	dropMode : { 
		RETURN : 0, 
		STAY : 1
	}, 
	repeatMode : { 
		infinity : Number.POSITIVE_INFINITY
	}, 
	
	resultType : { 
		STRING : 0, 
		DOM: 1, 
		JSON : 2
	}, 
	Node : {}, 
	Form : {}, 
	Cookie : {}, 
	DaD: { 
		DragDrops : [], 
		mouseOffset : null,
		iMouseDown  : false,
		lMouseState : false, 
		dragObject  : null,
		
		DragDrops   : [],
		curTarget   : null,
		lastTarget  : null,
		dragHelper  : null,
		tempDiv     : null,
		rootParent  : null,
		rootSibling : null, 
		
		droppable : []
	}, 
	Mouse: {
		x : 0, 
		y : 0, 
		button : 0
	},
  
	MArray : {}
}

Majax.dResultType = Majax.resultType.STRING;
Majax.insert = Majax.insertMode.REPLACE;
Majax.repeat = Majax.repeatMode.infinity; 

Number.prototype.NaN0=function(){return isNaN(this)?0:this;}

/** 
 * Returns position of element. 
 * @param	el	element
 */
Majax.getPosition = function(obj)
{
	return Majax.Node.getPosition(obj);
}

/**
 * Writes informations into log box.
 * @param	str		log message
 */
Majax.log = function(str)
{
	var el = Majax.$('majaxLogger');
	if (!el) { 
		Majax._createBox('majaxLogger');
	}
	
	el.innerHTML += str+"<br />";
}

/**
 * Writes informations into information box.
 * @param	str		message
 */
Majax.info = function(str)
{
	var el = Majax.$('majaxInfo')
	if (!el) { 
		Majax._createBox('majaxInfo');
	}
	
	el.innerHTML = str+"<br />";
}

/**
 * Creates absolute positioned box with id and appends them to body.
 * @param	id	identifier
 */
Majax._createBox = function(id)
{
	var obj = document.createElement('DIV');
	obj.style.cssText = 'position:absolute; border:1px solid red; padding: 1em;';
	obj.id = id;
	document.body.appendChild(obj);	
}
 
/**
 * First tries to find element with id=<code>name</code>, 
 * on failure returns elements with class=<code>name</code>. 
 *
 * @param	name		element id/class name
 * @param	parent		parent node, if empty, document is used
 * @param	tagName		tag of element/s
 */ 
Majax.get = function(name, parent, tagName) { 
  	var el = Majax.getById(name, parent, tagName);
  	if (el) { 
  		return el;
  	} else { 
  		return Majax.getByClass(name, parent, tagName);
  	}
}

/**
 * Returns element with id. If parent is specified node must be their child. 
 * If tagName name is specified , than node must have this type. 
 * 
 * @param	id			element id name
 * @param	parent		parent node, if empty, document is used
 * @param	tagName		tag of element/s 
 */
Majax.getById = function(id, parent, tagName)
{
	if (!parent) { 
		parent = document;
	}

	var el = parent.getElementById(id);	
	
	if (!tagName || tagName == '*') { 
		return el;
	}
	
	if ( el && el.nodeName == tagName.toUpperCase() ) { 
		return el;
	} else { 
		return null;
	} 	
}

/// Shortcut for Majax.getId
Majax.$ = function(id, parent, tagName)
{ 
	return Majax.getById(id, parent, tagName);
}

/**
 * Returns element with specified className. If parent is specified node must be their child. 
 * If tagName name is specified , than node must have this type. 
 * 
 * @param	className	element class name
 * @param	parent		parent node, if empty, document is used
 * @param	tagName		tag of element/s 
 */
Majax.getByClass = function (className, parent, tagName) 
{
 	if (!tagName) { 
 		tagName = "*";
 	}
 	
 	if (!parent) { 
 		parent = document;
 	}
 	nodes = parent.getElementsByTagName(tagName);
 	
 
 	var regexp = new RegExp('\\b' + className + '\\b');
 	var result = new Array();
 	
 	for (i in nodes) { 
 		item = nodes[i];
 		if(regexp.test(item.className)) {
   			result.push(item);
  		}
 	}
 	return result;
}

/// Shortcut for Majax.getByClass
Majax.$$ = function(className, parent, tagName)
{ 
	return Majax.getByClass(className, parent, tagName);
}

/** 
 * Automaticly adds all forms, that class "majaxForm" to forms for 
 * automatic processing. 
 */
Majax._addForms = function()
{
	el = Majax.$$('majaxForm', null, 'form');
	for ( i in el ) { 
		Majax.Form.add(el[i]);
	}	
}



// ==============================================
// Cookies section - begin
// ==============================================
Majax.Cookies = {
	/// Inits cookies. 
	init: function () {
		var allCookies = document.cookie.split('; ');
		for (var i=0;i<allCookies.length;i++) {
			var cookiePair = allCookies[i].split('=');
			this[cookiePair[0]] = cookiePair[1];
		}
	},
 
 	/// Creates cookie
	create: function (name,value,days) {
		if (days) {
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			var expires = "; expires="+date.toGMTString();
		}
		else var expires = "";
		document.cookie = name+"="+value+expires+"; path=/";
		this[name] = value;
	},
 
 	/// Erases cookie
	erase: function (name) {
		this.create(name,'',-1);
		this[name] = undefined;
	}, 
 
 	/// Reads cookie
 	read : function (name) {
		return this[name];
	}
}
// ==============================================
// Cookies section - end
// ==============================================


// ==============================================
// DaD section - begin
// ==============================================

/**
 * Provieds operations for Drag & Drop.
 */
Majax.DaD.onMouseMove = function(ev)
{
	//ev         = ev || window.event;
	var target   = ev.target || ev.srcElement;
	
	var mousePos = Majax.Mouse.getCoords(ev);

	if(Majax.DaD.lastTarget && (target!==Majax.DaD.lastTarget)){
		// mouseOut event - fires if the item the mouse is on has changed
	}

	 // if the mouse was moved over an element that is draggable
	if(!Majax.Node.hasClass(target, "majaxDraggableNow") && 
		Majax.Node.hasClass(target, "majaxDraggable")){

		// mouseOver event - Change the item's class if necessary
		
		/* M
		if(target!=Majax.DaD.lastTarget){
			var oClass = target.getAttribute('overClass');
			if(oClass){
				target.setAttribute('origClass', target.className);
				target.className = oClass;
			}
		}

		*/
		
		// if the user is just starting to drag the element
		if(Majax.DaD.iMouseDown && !Majax.DaD.lMouseState){
			Majax.Node.addClass(target, "majaxDraggableNow");

			Majax.DaD.curTarget     = target;

			// Record the mouse x and y offset for the element
			Majax.DaD.rootParent    = Majax.DaD.curTarget.parentNode;
			Majax.DaD.rootSibling   = Majax.DaD.curTarget.nextSibling;

			Majax.DaD.mouseOffset   = Majax.Mouse.getOffset(target, ev);

			// We remove anything that is in our dragHelper DIV so we can put a new item in it.
			for(var i=0; i<Majax.DaD.dragHelper.childNodes.length; i++) 
				Majax.DaD.dragHelper.removeChild(Majax.DaD.dragHelper.childNodes[i]);

			// Make a copy of the current item and put it in our drag helper.
			Majax.DaD.dragHelper.appendChild(Majax.DaD.curTarget.cloneNode(true));
			Majax.DaD.dragHelper.style.display = 'block';

			// set the class on our helper DIV if necessary
			/* M
			var dragClass = Majax.DaD.curTarget.getAttribute('dragClass');
			if(dragClass){
				Majax.DaD.dragHelper.firstChild.className = dragClass;
			}
			*/
			
			// disable dragging from our helper DIV (it's already being dragged)
			Majax.Node.removeClass(Majax.DaD.dragHelper.firstChild, "majaxDraggable");

			Majax.Node.setMajaxAttribute(Majax.DaD.curTarget, 'startWidth', parseInt(Majax.DaD.curTarget.offsetWidth));
			Majax.Node.setMajaxAttribute(Majax.DaD.curTarget, 'startHeight', parseInt(Majax.DaD.curTarget.offsetHeight));
			
			Majax.DaD.curTarget.style.display  = 'none';
			
			var dragConts = Majax.DaD.droppable;

			// loop through each possible drop container
			for(var i=0; i<dragConts.length; i++){
				
				var pos = Majax.getPosition(dragConts[i]);
		
				Majax.Node.setMajaxAttribute(dragConts[i], 'startWidth',  parseInt(dragConts[i].offsetWidth));
				Majax.Node.setMajaxAttribute(dragConts[i], 'startHeight', parseInt(dragConts[i].offsetHeight));
				Majax.Node.setMajaxAttribute(dragConts[i], 'startLeft',   pos.x);
				Majax.Node.setMajaxAttribute(dragConts[i], 'startTop',    pos.y);
				
				// loop through each child element of each container
				for(var j=0; j<dragConts[i].childNodes.length; j++){
					with(dragConts[i].childNodes[j]){
						if((dragConts[i].childNodes[j].nodeName=='#text') || (dragConts[i].childNodes[j]==Majax.DaD.curTarget)) continue;

						var pos = Majax.getPosition(dragConts[i].childNodes[j]);

						// save the width, height and position of each element
						Majax.Node.setMajaxAttribute(dragConts[i].childNodes[j], 'startWidth',  parseInt(dragConts[i].childNodes[j].offsetWidth));
						Majax.Node.setMajaxAttribute(dragConts[i].childNodes[j], 'startHeight', parseInt(dragConts[i].childNodes[j].offsetHeight));
						Majax.Node.setMajaxAttribute(dragConts[i].childNodes[j], 'startLeft',   pos.x);
						Majax.Node.setMajaxAttribute(dragConts[i].childNodes[j], 'startTop',    pos.y);
					}
				}
			}
		}
	}

	// If we get in here we are dragging something
	if(Majax.DaD.curTarget){
		// move our helper div to wherever the mouse is (adjusted by mouseOffset)
		Majax.DaD.dragHelper.style.top  = (mousePos.y - Majax.DaD.mouseOffset.y) + "px";
		Majax.DaD.dragHelper.style.left = (mousePos.x - Majax.DaD.mouseOffset.x) + "px";

		var dragConts  = Majax.DaD.droppable; 
		var activeCont = null;

		var xPos = mousePos.x - Majax.DaD.mouseOffset.x + (parseInt(Majax.Node.getMajaxAttribute(Majax.DaD.curTarget, 'startWidth')) /2);
		var yPos = mousePos.y - Majax.DaD.mouseOffset.y + (parseInt(Majax.Node.getMajaxAttribute(Majax.DaD.curTarget, 'startHeight'))/2);

		// check each drop container to see if our target object is "inside" the container
		for(var i=0; i<dragConts.length; i++){
			var x1 = parseInt(Majax.Node.getMajaxAttribute(dragConts[i], 'startLeft'));
			var y1 = parseInt(Majax.Node.getMajaxAttribute(dragConts[i], 'startTop'));
			var width = parseInt(Majax.Node.getMajaxAttribute(dragConts[i], 'startWidth'));
			var height = parseInt(Majax.Node.getMajaxAttribute(dragConts[i], 'startHeight'));
									
			if( (x1 < xPos) &&
				(y1 < yPos) &&
				((x1 + width) > xPos) &&
				((y1 + height) > yPos)){

					activeCont = dragConts[i];

					break;
			}
		}

		// Our target object is in one of our containers.  Check to see where our div belongs
		if(activeCont){
			// beforeNode will hold the first node AFTER where our div belongs
			var beforeNode = null;

			// loop through each child node (skipping text nodes).
			for(var i=activeCont.childNodes.length-1; i>=0; i--){
				if(activeCont.childNodes[i].nodeName=='#text') continue;

				// if the current item is "After" the item being dragged
				
				var x1 = parseInt(Majax.Node.getMajaxAttribute(activeCont.childNodes[i], 'startLeft'));
				var y1 = parseInt(Majax.Node.getMajaxAttribute(activeCont.childNodes[i], 'startTop'));
				var width = parseInt(Majax.Node.getMajaxAttribute(activeCont.childNodes[i], 'startWidth'));
				var height = parseInt(Majax.Node.getMajaxAttribute(activeCont.childNodes[i], 'startHeight'));
									
				if(	Majax.DaD.curTarget != activeCont.childNodes[i] &&
					((x1 + width)  > xPos) &&
					((y1 + height) > yPos) ){
						beforeNode = activeCont.childNodes[i];
				}
			}

			// the item being dragged belongs before another item
			if(beforeNode){
				if(beforeNode!=Majax.DaD.curTarget.nextSibling){
					activeCont.insertBefore(Majax.DaD.curTarget, beforeNode);
				}

			// the item being dragged belongs at the end of the current container
			} else {
				if((Majax.DaD.curTarget.nextSibling) || (Majax.DaD.curTarget.parentNode!=activeCont)){
					activeCont.appendChild(Majax.DaD.curTarget);
				}
			}

			// make our drag item visible
			if(Majax.DaD.curTarget.style.display!=''){
				Majax.DaD.curTarget.style.display  = '';
			}
		} else {

			// our drag item is not in a container, so hide it.
			if(Majax.DaD.curTarget.style.display!='none'){
				Majax.DaD.curTarget.style.display  = 'none';
			}
		}
	}

	// track the current mouse state so we can compare against it next time
	Majax.DaD.lMouseState = Majax.DaD.iMouseDown;

	// mouseMove target
	Majax.DaD.lastTarget  = target;

	// track the current mouse state so we can compare against it next time
	Majax.DaD.lMouseState = Majax.DaD.iMouseDown;

	// this helps prevent items on the page from being highlighted while dragging
	return false;
}

Majax.DaD.onMouseUp = function(ev){
	if(Majax.DaD.curTarget){
		// hide our helper object - it is no longer needed
		Majax.DaD.dragHelper.style.display = 'none';

		// if the drag item is invisible put it back where it was before moving it
		if(Majax.DaD.curTarget.style.display == 'none'){
			if(Majax.DaD.rootSibling){
				Majax.DaD.rootParent.insertBefore(Majax.DaD.curTarget, Majax.DaD.rootSibling);
			} else {
				Majax.DaD.rootParent.appendChild(Majax.DaD.curTarget);
			}
		}

		// make sure the drag item is visible
		Majax.DaD.curTarget.style.display = '';
		Majax.Node.removeClass(Majax.DaD.curTarget, "majaxDraggableNow");
		Majax.Node.addClass(Majax.DaD.curTarget, "majaxDraggable");			
	}
	
	Majax.DaD.curTarget  = null;
	Majax.DaD.iMouseDown = false;
}

Majax.DaD.onMouseDown = function(ev){
	Majax.DaD.iMouseDown = true;
	if(Majax.DaD.lastTarget){
		return false;
	}
}

/**
 * Makes elements droppable - i. e. it is possible to drop on them
 * another element.
 */
Majax.DaD.makeDroppable = function() 
{
	for(var i=0; i<arguments.length; i++){
		var cObj = arguments[i];
		if (cObj) { 
			Majax.Node.addClass(cObj, "majaxDroppable");
			Majax.DaD.droppable.push(cObj);
		}
	}
}

/**
 * Returns true, if element is droppable. 
 * @param	el
 * @return boolean	true, if droppable, false otherwise
 */
Majax.DaD.isDroppable = function(el) {
	return Majax.Node.hasClass("majaxDroppable");
}


/**
 * Makes node undroppable. 
 */
Majax.DaD.makeUndroppable = function()
{
	for(var i=0; i<arguments.length; i++){
		var cObj = arguments[i];
		if (cObj) { 
			Majax.Node.removeClass(cObj, "majaxDroppable");
			for (var j = 0; j < Majax.DaD.droppable.length; j++) { 
				if (Majax.DaD.droppable[j] == cObj) { 
					Majax.MArray.remove(Majax.DaD.droppable, j);
				}
			}
		}
	}
}

/**
 * Makes elements droggable - i. e. it is possible to drag them. 
 */
Majax.DaD.makeDraggable = function()
{
	for(var i=0; i<arguments.length; i++){
		var cObj = arguments[i];

		if (cObj instanceof NodeList) { 
			for (j = 0; j < cObj.length; j++) { 
				if (cObj[j].nodeName !='#text') {
					Majax.DaD.makeDraggable(cObj[j]);
				}				
			}
		} else { 
			Majax.Node.addClass(cObj, "majaxDraggable");
		}
	}
}

/**
 * Returns true, if element is draggable. 
 * @param	el
 * @return boolean	true, if draggable, false otherwise
 */
Majax.DaD.isDraggable = function(el)
{
	return Majax.Node.hasClass("majaxDraggable");
}

/**
 * Makes node undraggable. 
 */
Majax.DaD.makeUndraggable = function()
{
	for(var i=0; i<arguments.length; i++){
		var cObj = arguments[i];
		if (cObj) { 
			Majax.Node.removeClass(cObj, "majaxDraggable");
			for (var j = 0; j < Majax.DaD.droppable.length; j++) { 
				if (Majax.DaD.droppable[j] == cObj) { 
					Majax.MArray.remove(Majax.DaD.droppable, j);
				}
			}
		}
	}
}

/**
 * Creates helper, it's called automaticly. 
 */
Majax.DaD._makeHelper = function()
{
	// Create our helper object that will show the item while dragging
	Majax.DaD.dragHelper = document.createElement('div');
	Majax.DaD.dragHelper.style.cssText = 'position:absolute;display:none;';
	document.body.appendChild(Majax.DaD.dragHelper);
}
// ==============================================
// DaD section - end
// ==============================================

// ==============================================
// Event section - begin
// ==============================================

/**
 * Provides API for event handeling. 
 */
Majax.Event = {
	/**
	 * Adds event handler. 
	 * @param	obj			element
	 * @param	evType		event type
	 * @param	fn			handler
	 * @param	useCapture	bubble or not
	 */
	add : function(obj, evType, fn, useCapture) {
		if (window.opera && (obj == window)) {
			obj = document;
		}
		if (obj.addEventListener){
			obj.addEventListener(evType, fn, useCapture);
			return true;
		} else if (obj.attachEvent){
			var r = obj.attachEvent("on"+evType, fn);
			return r;
		} else {
			return false;
		}
	},	
 
 	/**
	 * Removes event handler. 
	 * @param	obj			element
	 * @param	evType		event type
	 * @param	useCapture	bubble or not
	 */
 	remove : function(obj, evType, fn, useCapture) {
		if (window.opera && (obj == window)) {
			obj = document;
		}
		if (obj.removeEventListener) {
			obj.removeEventListener(evType, fn, useCapture);
			return true;
		} else if (obj.detachEvent) {
			var r = obj.detachEvent("on"+evType, fn);
			return r;
		} else {
			return false;
		}
	},
 
 	/**
 	 * Fixs event to be platform independent.
	 * @param	e	event
	 */
	fix : function(e) {
		if (!e && window.event) e = window.event;
		if (!e.target) e.target = e.srcElement;
		if (!e.preventDefault) e.preventDefault = function() {
			e.returnValue = false;
		}
	}
}
// ==============================================
// Event section - end
// ==============================================


// ==============================================
// Form section - begin
// ==============================================

/**
 * Adds form for automatic processing. 
 * @param	form	id, or form element
 */
Majax.Form.add = function(form)
{
	if (typeof(form) == 'string') { 
		f = Majax.$(form);
	} else { 
		f = form;
	}
	f.onsubmit = new Function("Majax.Form.submit('"+f.id+"'); return false;");
}

/**
 * Submits form with id. 
 * @param	id		identifier
 */
Majax.Form.submit = function(id)
{
	var i; 
	var f;
	var params;
	f = Majax.$(id)	;
	if (!f) { 
		return;
	}
	
	params = new Object();
	inputs = f.getElementsByTagName('input');
	for (i = 0; i < inputs.length; i++) { 
		inp = inputs[i];
		if (inp.name) { 
			params[inp.name] = inp.value;
		}
	}
	
	txts = f.getElementsByTagName('textarea');	
	for (i = 0; i < txts.length; i++) { 
		txt = txts[i];
		if (txt.name) { 
			params[txt.name] = txt.value;
		}
	}
	
	sels = f.getElementsByTagName('select');	
	for (i = 0; i < sels.length; i++) { 
		sel = sels[i];
		if (sel.name) { 
			params[sel.name] = sel.options[sel.selectedIndex].value;
		}
	}	
	
	action = f.getAttribute('action');
	method = f.getAttribute('method');
	// alert(action+", " + method);

	
	new Majax.Request(
	  		{	  			
	  			name: 'majaxForm_'+id,
	  			url: action,
	  			resultType: Majax.resultType.JSON, 
	    		method: method,
	    		params: params, 
	   			form: f, 
	    		onSuccess: function(result, httpRequest, req){
	      			Majax.Form.response(result, req);
	    		},
	    		onFailure: function(req){ 
	    			Majax.Form.response('{error: 1}', req);
	    		}
	  		});	
	return false;

}

/**
 * Processes response on form submition. 
 */
Majax.Form.response = function(result, req)
{
	m = result['__majax__'];
	if ( !m ) { 
		return false;
	}
	
	// alerts
	alerts = m['alerts'];
	if ( alerts ) { 
		msg = "";
		for (i = 0; i < alerts.length; i++) { 
			if (i > 0) { 
				msg += "\n";
			}
			msg += alerts[i];
		}
		if ( msg ) { 
			alert(msg);
		}
	}
	
	// automatic submit
	if ( m.formValidity && m.submitOnSuccess && req.form) { 
		req.form.submit();
	}
}
// ==============================================
// Form section - end
// ==============================================


// ==============================================
// Node section - begin
// ==============================================

/**
 * Removes all childs from parent node and inserts new child.
 * @param	parent		parent node
 * @param	newChild	child node
 */
Majax.Node.replaceChild = function(parent, newChild)
{
	if (!parent) { 
		return;
	}
	
	while (parent.firstChild) { 
		parent.removeChild(parent.firstChild);
	}
	
	if (newChild) { 
		parent.appendChild(newChild);
	}
}

/**
 * Inserts newChild to parent on specified position. 
 * @param	parent		parent node
 * @param	newChild	new child
 * @param	position	position of new child
 */
Majax.Node.insert = function(parent, newChild, position)
{
	if (position == undefined) { 
		position = Majax.insertMode.LAST;
	}
	if (!parent || !newChild) { 
		return;
	}

	chC = parent.childNodes.length;
	// 1. pozice
	if (position <= 0) { 
		if (chC == 0) { 
			parent.appendChild(newChild);
		} else { 
			parent.insertBefore(newChild, parent.firstChild);
		}
		return;
	}
	
	if (position >= chC) { 
		parent.appendChild(newChild);
		return;
	}

	parent.insertBefore(newChild, parent.childNodes[position]);
}

/**
 * Returns position of element. 
 * @param	obj		element
 */
Majax.Node.getPosition = function(obj)
{
	var left = 0;
	var top  = 0;

	while (obj.offsetParent){
		left += obj.offsetLeft;
		top  += obj.offsetTop;
		obj     = obj.offsetParent;
	}

	left += obj.offsetLeft;
	top  += obj.offsetTop;

	return {x:left, y:top};
}

/**
 * Returns true if node has class name className. 
 * @param	node		element
 * @param	className	class name
 * @return	true if node has specified class name, false otherwise
 */
Majax.Node.hasClass = function(node, className)
{
	if (!node) { 
		return false;
	}
 	var regexp = new RegExp('\\b' + className + '\\b');
 	
 	return regexp.test(node.className);
}

/**
 * Adds new class to specified to node. 
 * @param	node		element
 * @param	className	class name
 */
Majax.Node.addClass = function(node, className)
{
	if (node && !Majax.Node.hasClass(node, className)) { 
		node.className += " "+className;
	}
}

/**
 * Removes class to specified to node. 
 * @param	node		element
 * @param	className	class name
 */
Majax.Node.removeClass = function(node, className)
{
	if (!node) { 
		return false;
	}
	var bef = node.className;
	
 	var regexp = new RegExp('\\b' + className + '\\b');
	node.className = node.className.replace(regexp, "", "g");
}

/**
 * Returns special inner MAJAX value of node. 
 * @param	node		element
 * @param	attName		attribute name
 */
Majax.Node.getMajaxAttribute = function(node, attName)
{
	if (node.__majax__) { 
		return node.__majax__[attName];
	} else { 
		return null;
	}
}

/**
 * Sets special inner MAJAX value. 
 * @param	node		element
 * @param	attName		attribute name
 * @param	value		value
 */
Majax.Node.setMajaxAttribute = function(node, attName, value)
{
	if (!node.__majax__) { 
		node.__majax__ = {};
	}
	
	node.__majax__[attName] = value;
}

// ==============================================
// NOde section - end
// ==============================================



// ==============================================
// MArray section - begin
// ==============================================

/**
 * Removes value from array on specified index.
 * @param	ar		array
 * @param	index	index
 */
Majax.MArray.remove = function(ar, index)
{
	var d = 0;
	for (var i = 0; i < ar.length; i++) { 
		if (i == index) { 
			delta = 1;
		} else { 
			ar[i - delta] = ar[delta];
		}
	}
	
	if (delta == 1) { 
		ar.pop();
	}
}
// ==============================================
// MArray section - end
// ==============================================


// ==============================================
// Mouse section - begin
// ==============================================

/**
 * Returns actual coordinates of mouse. 
 * @param	ev		event
 */
Majax.Mouse.getCoords = function(ev)
{
	if(ev.pageX || ev.pageY){
		return {x:ev.pageX, y:ev.pageY};
	}
	return {
		x:ev.clientX + document.body.scrollLeft - document.body.clientLeft,
		y:ev.clientY + document.body.scrollTop  - document.body.clientTop
	};
}

/**
 * Returns offset of mouse position on target. 
 * @param	target		element
 * @param	ev			event
 */
Majax.Mouse.getOffset = function(target, ev){
	ev = ev || window.event;
	var docPos    = Majax.getPosition(target);
	var mousePos  = Majax.Mouse.getCoords(ev);
	return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
}

/**
 * Alias for Majax.Mouse.getCoors
 */
Majax.Mouse.getPosition = function(ev)
{
	return Majax.Mouse.getCoords(ev);
}
// ==============================================
// Mouse section - end
// ==============================================

// ==============================================
// Request section - begin
// ==============================================

/**
 * Creates AJAX request. 
 * { 
 *		id			- identifier
 *		params		- special parameters
 *		url			- url for request
 *		resultType	- result type
 *		update
 *		repeat
 *		onSuccess
 *		onLoading
 *		onFailure
 *		insert
 *		send
 *	}
 */
Majax.Request = function(arg) 
{ 
	this.arg = arg; 
	
	this.id = majaxInstanceId++;
		
	this.httpRequest = Majax.createRequest();
	
	// element id
	this.elementId = arg.id;

	// method	
	method = Majax.method;
	if (arg.method == "post" || arg.method == "POST") { 
		method = "post";
	}
	
	// params
	this.params = arg.params;
	args = "";
	if (arg.params) { 
		for (el in arg.params) { 
			args += el+"="+arg.params[el]+"&";
		}
	}
	if (arg.name) { 
		args += Majax.paramName+"="+arg.name;
		this.name = arg.name;
	}
	this.args = args;
	
	// url
	url = (arg.url ? arg.url : Majax.url );
	
	if (method == "get") { 
		if (url.indexOf("?") != -1) { 
			url += "&"+args;
		} else { 
			url += "?"+args;
		}
	}
	
	// result
	this.resultType = (arg.resultType ? arg.resultType : Majax.dResultType );
	
	// insert
	this.insert = ( arg.insert == undefined ? 
		Majax.insert : arg.insert );
		
	// update
	this.update = ( arg.update == undefined ? 
		0 : arg.update );
		
	// repeat
	if ( arg.repeat == undefined ) { 
		if (this.update == 0) { 
			this.repeat = 1;
		} else { 
			this.repeat = Majax.repeat;
		}
	} else { 
		this.repeat = arg.repeat;
	}	
	
	// oprava update
	if (this.repeat > 1 && this.update == 0) { 
		this.update = Majax.update;
	}
		 

	// handlers
	if (arg.onSuccess) { 
		this.onSuccess = arg.onSuccess;
	}
	
	this.onLoading = ( arg.onLoading ? 
		arg.onLoading : Majax.onLoading);
		
	this.onFailure = ( arg.onFailure ? 
		arg.onFailure : Majax.onFailure);

    this.httpRequest.open(method, url, true);
    this.httpRequest.setRequestHeader('Content-Type',
    		'application/x-www-form-urlencoded'); 	
	t = new Date().toString();
	
	majaxInstance[this.id] = this;
	
    f = new Function("id = '"+this.id+"';  Majax.Request.response(id);");
	
	//form
	this.form = arg.form;

	this.httpRequest.onreadystatechange = f;
	
	this._send();
	if (this.repeat > 0) {
		setTimeout("Majax.Request.send("+this.id+");", this.update);
	}
}

/**
 * Processes response for AJAX request. 
 */
Majax.Request.response = function() 
{ 
	req = majaxInstance[arguments[0]];
	http = req.httpRequest;	

	status = 200;

	if ( http.readyState == 4 ) { 
		try { 
			status = http.status;
		} catch(e) {}
	}
	
	if ( status == 200 ) { // http.status == 200 
		if (http.readyState == Majax.state.FINISHED) { 
			if (req.onSuccess) { 
				req.onSuccess(req._eval(http.responseText), 
						  http, req);
			} else if (req.elementId) { 
				req._insert();				
			}			
		} else { 
			if (req.onLoading) { 
				req.onLoading(http, req);
			}
		}
	} else if ( status == 404 ) { 
		if (req.onFailure) { 
			req.onFailure(req._eval(http.responseText), 
					  http, req);
		}	
	} else { 
		if (req.onLoading) { 
			req.onLoading(http, req);
		}
	}	
}

Majax.Request.prototype._eval = function(arg) 
{ 
	switch (this.resultType ) { 
		case Majax.resultType.STRING: 
			return arg;
		case Majax.resultType.DOM:
			//alert(arg);	
			//str = 'd=document.createElement("div");t=document.createTextNode("Nazdaaaaaaaaaaaaaaar"); d.appendChild(t); document.getElementById("footer").appendChild(d);';
			//eval(str);
			return eval(arg);
		case Majax.resultType.JSON: 
			return eval('('+arg+')');
	}
}

Majax.Request.prototype._insert = function()
{
	http = this.httpRequest;
	res = this._eval(http.responseText);
	el = Majax.getById(this.elementId);
	if (!el) {
		return;
	} 
	if (typeof(res) == 'object') { 
		switch (this.insert) { 
			case Majax.insertMode.REPLACE: 
				Majax.Node.replaceChild(el, res);
				break;
			default:
				Majax.Node.insert(el, res, this.insert);
		}
	} else { 
		switch (this.insert) { 
			case Majax.insertMode.REPLACE: 
				el.innerHTML = res;
				break;
			case Majax.insertMode.FIRST: 
				el.innerHTML = res + el.innerHTML;
				break;
			default:
				el.innerHTML += res;
		}
	}
}

Majax.Request.send = function()
{
	req = majaxInstance[arguments[0]];
	if (req.arg.repeat > 0) { 
		n = new Majax.Request(req.arg);
	}
}

Majax.Request.prototype._send = function()
{
	this.httpRequest.send(this.args);
	this.repeat--;
	this.arg.repeat--;
}
// ==============================================
// Request section - end
// ==============================================

Majax.onLoad = function(e)
{
	Majax.Event.add(window, 'mouseup', new Function("e", "Majax.DaD.onMouseUp(e);"));
	Majax.Event.add(window, 'mousemove', new Function("e", "Majax.DaD.onMouseMove(e);"));
	Majax.Event.add(window, 'mousedown', new Function("e", "Majax.DaD.onMouseDown(e);"));	
	Majax._addForms();
	Majax.Cookies.init();
	Majax.DaD._makeHelper();
}

/* initialization */
Majax.Event.add(window, 'load', new Function("e", "Majax.onLoad(e)"), true);
